; bitflip_delay_subroutine.a51		bitflip program, with delay for full-speed operation

; rev path 3/16
	$NOSYMBOLS	; keeps listing short
	$INCLUDE (C:\SiLabs\MCU\INC\c8051f410.inc) 

	ORG 0					; tells assembler the address at which to place this code

         
			ACALL USUAL_SETUP
      SETB P0.0			;  start with LED OFF (it's active low)

FLIPIT:			CPL P0.0             ; toggle LED
			ACALL DELAY					; waste some time
			SJMP FLIPIT					; do it forever
		

;--- SUBROUTINES ----
DELAY:     PUSH ACC    ; save the registers that this routine will mess up
          PUSH B
          PUSH 4      ; this saves register R4--in the zero'th set of registers

          MOV A,#0				; maximize two delay values (0 is max because dec before test)
          MOV B,#0			  ; ...and second loop delay value
          MOV R4, #10h    ; 1 second delay: this multiplies the 64K other loops

INNERLOOP:	DJNZ B, INNERLOOP		; count down innermost loop, till inner hits zero
          DJNZ ACC,INNERLOOP	; ...then dec second loop, and start inner again.
          DJNZ R4, INNERLOOP	; now, with second at zero, decrement the outermost loop 

          POP 4
          POP B
          POP ACC
          RET                ; back to main program

USUAL_SETUP: ANL   PCA0MD, #NOT(040h)        ; Disable the WDT.
                                             ; Clear Watchdog Enable bit
				; Configure the Oscillator
             ORL   OSCICN, #04h         ; sysclk = 24.5 Mhz / 8


         ; Enable the Port I/O Crossbar

            MOV   XBR1, #40h           ; Enable Crossbar
						RET
		END
